/* -------------------------------------------------------------------------
 * Copyright (c) 2009 Steve Jolly. All Rights Reserved
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * See the COPYING file for a copy of the GNU General Public Licence.
 *
 * -------------------------------------------------------------------------
 */
package net.elvum.hpgen;

import javax.microedition.rms.RecordStoreException;
import net.intertwingly.SHA1;
import com.twmacinta.util.MD5;
import java.io.UnsupportedEncodingException;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

/**
 * NB: This code was developed in NetBeans 6.5 using the Visual Designer.
 * @author Steve Jolly
 */
public class HashPasswordGenerator extends MIDlet implements CommandListener {

    private boolean midletPaused = false;
    private MD5 md5 = new MD5();
    private HPGenPrefs prefs = HPGenPrefs.getInstance();

    //<editor-fold defaultstate="collapsed" desc=" Generated Fields ">//GEN-BEGIN:|fields|0|
    private java.util.Hashtable __previousDisplayables = new java.util.Hashtable();
    private Command exitCommand;
    private Command generateCommand;
    private Command okCommand;
    private Command preferencesCommand;
    private Command cancelCommand;
    private Command chooseDomainCommand;
    private Command okChooseDomainCommand;
    private Command cancelChooseDomainCommand;
    private Command manageDomainsCommand;
    private Command aboutCommand;
    private Command deleteCommand;
    private Command selectAllCommand;
    private Command backCommand;
    private Command selectNoneCommand;
    private Command okCommand1;
    private Form mainForm;
    private TextField passwordField;
    private StringItem generatedPassword;
    private TextField domainField;
    private Form preferencesForm;
    private ChoiceGroup choiceHashFunction;
    private ChoiceGroup choicePresentation;
    private TextField lengthField;
    private ChoiceGroup choiceStoreDomains;
    private Form chooseDomainForm;
    private ChoiceGroup choiceDomain;
    private Form manageDomainsForm;
    private ChoiceGroup manageDomainsChoiceGroup;
    private Form aboutForm;
    private StringItem stringItem1;
    //</editor-fold>//GEN-END:|fields|0|

    /**
     * The HashPasswordGenerator constructor.
     */
    public HashPasswordGenerator() {
    }

    /**
     * Called when the user selects "Delete Selected" in the manageDomainsForm
     */
    private void deleteDomains() {
        boolean[] selected = new boolean[manageDomainsChoiceGroup.size()];
        manageDomainsChoiceGroup.getSelectedFlags(selected);
        for (int i = 0; i < selected.length; i++) {
            if (selected[i]) {
                try {
                    prefs.deleteDomain(manageDomainsChoiceGroup.getString(i));
                } catch (RecordStoreException ex) {
                    ex.printStackTrace();
                }
            }
        }
        refreshManageDomainsForm(prefs.getDomainList());
    }

    /** Called when the manageDomainsForm is switched to, or when the user
     * deletes domains from the list, to refresh that list.
     */
    private void refreshManageDomainsForm(String[] domains) {
        while (manageDomainsChoiceGroup.size() > 0) {
            manageDomainsChoiceGroup.delete(0);
        }
        for (int i = domains.length - 1; i >= 0; i--) {
            manageDomainsChoiceGroup.append(domains[i], null);
        }
    }

    /**
     * Called when the user selects "Select All" in the manageDomainsForm
     */
    private void selectAllDomains() {
        boolean[] selected = new boolean[manageDomainsChoiceGroup.size()];
        for (int i = 0; i < selected.length; i++) {
            selected[i] = true;
        }
        manageDomainsChoiceGroup.setSelectedFlags(selected);
    }

    /**
     * Called when the user selects "Select None" in the manageDomainsForm
     */
    private void selectNoDomains() {
        boolean[] selected = new boolean[manageDomainsChoiceGroup.size()];
        for (int i = 0; i < selected.length; i++) {
            selected[i] = false;
        }
        manageDomainsChoiceGroup.setSelectedFlags(selected);
    }

    //<editor-fold defaultstate="collapsed" desc=" Generated Methods ">//GEN-BEGIN:|methods|0|
    /**
     * Switches a display to previous displayable of the current displayable.
     * The <code>display</code> instance is obtain from the <code>getDisplay</code> method.
     */
    private void switchToPreviousDisplayable() {
        Displayable __currentDisplayable = getDisplay().getCurrent();
        if (__currentDisplayable != null) {
            Displayable __nextDisplayable = (Displayable) __previousDisplayables.get(__currentDisplayable);
            if (__nextDisplayable != null) {
                switchDisplayable(null, __nextDisplayable);
            }
        }
    }
    //</editor-fold>//GEN-END:|methods|0|

    //<editor-fold defaultstate="collapsed" desc=" Generated Method: initialize ">//GEN-BEGIN:|0-initialize|0|0-preInitialize
    /**
     * Initilizes the application.
     * It is called only once when the MIDlet is started. The method is called before the <code>startMIDlet</code> method.
     */
    private void initialize() {//GEN-END:|0-initialize|0|0-preInitialize
        // write pre-initialize user code here
//GEN-LINE:|0-initialize|1|0-postInitialize
        // write post-initialize user code here
    }//GEN-BEGIN:|0-initialize|2|
    //</editor-fold>//GEN-END:|0-initialize|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Method: startMIDlet ">//GEN-BEGIN:|3-startMIDlet|0|3-preAction
    /**
     * Performs an action assigned to the Mobile Device - MIDlet Started point.
     */
    public void startMIDlet() {//GEN-END:|3-startMIDlet|0|3-preAction
        // write pre-action user code here
        switchDisplayable(null, getMainForm());//GEN-LINE:|3-startMIDlet|1|3-postAction
    // write post-action user code here
    }//GEN-BEGIN:|3-startMIDlet|2|
    //</editor-fold>//GEN-END:|3-startMIDlet|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Method: resumeMIDlet ">//GEN-BEGIN:|4-resumeMIDlet|0|4-preAction
    /**
     * Performs an action assigned to the Mobile Device - MIDlet Resumed point.
     */
    public void resumeMIDlet() {//GEN-END:|4-resumeMIDlet|0|4-preAction
        // write pre-action user code here
//GEN-LINE:|4-resumeMIDlet|1|4-postAction
        // write post-action user code here
    }//GEN-BEGIN:|4-resumeMIDlet|2|
    //</editor-fold>//GEN-END:|4-resumeMIDlet|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Method: switchDisplayable ">//GEN-BEGIN:|5-switchDisplayable|0|5-preSwitch
    /**
     * Switches a current displayable in a display. The <code>display</code> instance is taken from <code>getDisplay</code> method. This method is used by all actions in the design for switching displayable.
     * @param alert the Alert which is temporarily set to the display; if <code>null</code>, then <code>nextDisplayable</code> is set immediately
     * @param nextDisplayable the Displayable to be set
     */
    public void switchDisplayable(Alert alert, Displayable nextDisplayable) {//GEN-END:|5-switchDisplayable|0|5-preSwitch
// write pre-switch user code here
        if (nextDisplayable.equals(getChooseDomainForm())) {
            String[] domains = prefs.getDomainList();
            if (domains.length == 0) {
                nextDisplayable = mainForm;
                alert = new Alert("No Domains Stored", "No domains are stored.  Enter one on the main screen - they will be stored automatically.", null, null);
            } else {
                while (choiceDomain.size() > 0) {
                    choiceDomain.delete(0);
                }
                for (int i = domains.length - 1; i >= 0; i--) {
                    choiceDomain.append(domains[i], null);
                }
            }
        } else if (nextDisplayable.equals(getManageDomainsForm())) {
            String[] domains = prefs.getDomainList();
            if (domains.length == 0) {
                nextDisplayable = mainForm;
                alert = new Alert("No Domains Stored", "No domains are stored.  Enter one on the main screen - they will be stored automatically.", null, null);
            } else {
                refreshManageDomainsForm(domains);
            }
        }
        Display display = getDisplay();//GEN-BEGIN:|5-switchDisplayable|1|5-postSwitch
        Displayable __currentDisplayable = display.getCurrent();
        if (__currentDisplayable != null  &&  nextDisplayable != null) {
            __previousDisplayables.put(nextDisplayable, __currentDisplayable);
        }
        if (alert == null) {
            display.setCurrent(nextDisplayable);
        } else {
            display.setCurrent(alert, nextDisplayable);
        }//GEN-END:|5-switchDisplayable|1|5-postSwitch
    // write post-switch user code here
    }//GEN-BEGIN:|5-switchDisplayable|2|
    //</editor-fold>//GEN-END:|5-switchDisplayable|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Method: commandAction for Displayables ">//GEN-BEGIN:|7-commandAction|0|7-preCommandAction
    /**
     * Called by a system to indicated that a command has been invoked on a particular displayable.
     * @param command the Command that was invoked
     * @param displayable the Displayable where the command was invoked
     */
    public void commandAction(Command command, Displayable displayable) {//GEN-END:|7-commandAction|0|7-preCommandAction
        // write pre-action user code here
        if (displayable == aboutForm) {//GEN-BEGIN:|7-commandAction|1|101-preAction
            if (command == okCommand1) {//GEN-END:|7-commandAction|1|101-preAction
                // write pre-action user code here
                switchToPreviousDisplayable();//GEN-LINE:|7-commandAction|2|101-postAction
            // write post-action user code here
            }//GEN-BEGIN:|7-commandAction|3|62-preAction
        } else if (displayable == chooseDomainForm) {
            if (command == cancelChooseDomainCommand) {//GEN-END:|7-commandAction|3|62-preAction
                // write pre-action user code here
                switchDisplayable(null, getMainForm());//GEN-LINE:|7-commandAction|4|62-postAction
            // write post-action user code here
            } else if (command == okChooseDomainCommand) {//GEN-LINE:|7-commandAction|5|60-preAction
                // write pre-action user code here
                selectDomain();//GEN-LINE:|7-commandAction|6|60-postAction
                switchDisplayable(null, getMainForm());
            // write post-action user code here
            }//GEN-BEGIN:|7-commandAction|7|74-preAction
        } else if (displayable == mainForm) {
            if (command == aboutCommand) {//GEN-END:|7-commandAction|7|74-preAction
                // write pre-action user code here
                switchDisplayable(null, getAboutForm());//GEN-LINE:|7-commandAction|8|74-postAction
            // write post-action user code here
            } else if (command == chooseDomainCommand) {//GEN-LINE:|7-commandAction|9|56-preAction
                // write pre-action user code here
                switchDisplayable(null, getChooseDomainForm());//GEN-LINE:|7-commandAction|10|56-postAction
            // write post-action user code here
            } else if (command == exitCommand) {//GEN-LINE:|7-commandAction|11|19-preAction
                // write pre-action user code here
                exitMIDlet();//GEN-LINE:|7-commandAction|12|19-postAction
            // write post-action user code here
            } else if (command == generateCommand) {//GEN-LINE:|7-commandAction|13|26-preAction
                // write pre-action user code here
                generate();//GEN-LINE:|7-commandAction|14|26-postAction
            // write post-action user code here
            } else if (command == manageDomainsCommand) {//GEN-LINE:|7-commandAction|15|78-preAction
                // write pre-action user code here
                switchDisplayable(null, getManageDomainsForm());//GEN-LINE:|7-commandAction|16|78-postAction
            // write post-action user code here
            } else if (command == preferencesCommand) {//GEN-LINE:|7-commandAction|17|33-preAction
                // write pre-action user code here
                switchDisplayable(null, getPreferencesForm());//GEN-LINE:|7-commandAction|18|33-postAction
            // write post-action user code here
            }//GEN-BEGIN:|7-commandAction|19|82-preAction
        } else if (displayable == manageDomainsForm) {
            if (command == backCommand) {//GEN-END:|7-commandAction|19|82-preAction
                // write pre-action user code here
                switchToPreviousDisplayable();//GEN-LINE:|7-commandAction|20|82-postAction
            // write post-action user code here
            } else if (command == deleteCommand) {//GEN-LINE:|7-commandAction|21|85-preAction
                // write pre-action user code here
                deleteDomains();//GEN-LINE:|7-commandAction|22|85-postAction
            // write post-action user code here
            } else if (command == selectAllCommand) {//GEN-LINE:|7-commandAction|23|87-preAction
                // write pre-action user code here
                selectAllDomains();//GEN-LINE:|7-commandAction|24|87-postAction
            // write post-action user code here
            } else if (command == selectNoneCommand) {//GEN-LINE:|7-commandAction|25|89-preAction
                // write pre-action user code here
                selectNoDomains();//GEN-LINE:|7-commandAction|26|89-postAction
            // write post-action user code here
            }//GEN-BEGIN:|7-commandAction|27|39-preAction
        } else if (displayable == preferencesForm) {
            if (command == cancelCommand) {//GEN-END:|7-commandAction|27|39-preAction
                // write pre-action user code here
                switchToPreviousDisplayable();//GEN-LINE:|7-commandAction|28|39-postAction
            // write post-action user code here
            } else if (command == okCommand) {//GEN-LINE:|7-commandAction|29|36-preAction
                // write pre-action user code here
                savePreferences();//GEN-LINE:|7-commandAction|30|36-postAction
                // write post-action user code here
                switchDisplayable(null, getMainForm());
            }//GEN-BEGIN:|7-commandAction|31|7-postCommandAction
        }//GEN-END:|7-commandAction|31|7-postCommandAction
    // write post-action user code here
    }//GEN-BEGIN:|7-commandAction|32|
    //</editor-fold>//GEN-END:|7-commandAction|32|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: exitCommand ">//GEN-BEGIN:|18-getter|0|18-preInit
    /**
     * Returns an initiliazed instance of exitCommand component.
     * @return the initialized component instance
     */
    public Command getExitCommand() {
        if (exitCommand == null) {//GEN-END:|18-getter|0|18-preInit
            // write pre-init user code here
            exitCommand = new Command("Exit", Command.EXIT, 5);//GEN-LINE:|18-getter|1|18-postInit
        // write post-init user code here
        }//GEN-BEGIN:|18-getter|2|
        return exitCommand;
    }
    //</editor-fold>//GEN-END:|18-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: mainForm ">//GEN-BEGIN:|14-getter|0|14-preInit
    /**
     * Returns an initiliazed instance of mainForm component.
     * @return the initialized component instance
     */
    public Form getMainForm() {
        if (mainForm == null) {//GEN-END:|14-getter|0|14-preInit
            // write pre-init user code here
            mainForm = new Form("Password Generator", new Item[] { getPasswordField(), getDomainField(), getGeneratedPassword() });//GEN-BEGIN:|14-getter|1|14-postInit
            mainForm.addCommand(getGenerateCommand());
            mainForm.addCommand(getChooseDomainCommand());
            mainForm.addCommand(getManageDomainsCommand());
            mainForm.addCommand(getPreferencesCommand());
            mainForm.addCommand(getAboutCommand());
            mainForm.addCommand(getExitCommand());
            mainForm.setCommandListener(this);//GEN-END:|14-getter|1|14-postInit
        // write post-init user code here
        }//GEN-BEGIN:|14-getter|2|
        return mainForm;
    }
    //</editor-fold>//GEN-END:|14-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: generateCommand ">//GEN-BEGIN:|25-getter|0|25-preInit
    /**
     * Returns an initiliazed instance of generateCommand component.
     * @return the initialized component instance
     */
    public Command getGenerateCommand() {
        if (generateCommand == null) {//GEN-END:|25-getter|0|25-preInit
            // write pre-init user code here
            generateCommand = new Command("Generate", Command.SCREEN, 0);//GEN-LINE:|25-getter|1|25-postInit
        // write post-init user code here
        }//GEN-BEGIN:|25-getter|2|
        return generateCommand;
    }
    //</editor-fold>//GEN-END:|25-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: passwordField ">//GEN-BEGIN:|24-getter|0|24-preInit
    /**
     * Returns an initiliazed instance of passwordField component.
     * @return the initialized component instance
     */
    public TextField getPasswordField() {
        if (passwordField == null) {//GEN-END:|24-getter|0|24-preInit
            // write pre-init user code here
            passwordField = new TextField("Enter Password:", null, 32, TextField.ANY | TextField.PASSWORD);//GEN-LINE:|24-getter|1|24-postInit
        // write post-init user code here
        }//GEN-BEGIN:|24-getter|2|
        return passwordField;
    }
    //</editor-fold>//GEN-END:|24-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: generatedPassword ">//GEN-BEGIN:|27-getter|0|27-preInit
    /**
     * Returns an initiliazed instance of generatedPassword component.
     * @return the initialized component instance
     */
    public StringItem getGeneratedPassword() {
        if (generatedPassword == null) {//GEN-END:|27-getter|0|27-preInit
            // write pre-init user code here
            generatedPassword = new StringItem("Generated Password:", null);//GEN-LINE:|27-getter|1|27-postInit
        // write post-init user code here
        }//GEN-BEGIN:|27-getter|2|
        return generatedPassword;
    }
    //</editor-fold>//GEN-END:|27-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: preferencesCommand ">//GEN-BEGIN:|32-getter|0|32-preInit
    /**
     * Returns an initiliazed instance of preferencesCommand component.
     * @return the initialized component instance
     */
    public Command getPreferencesCommand() {
        if (preferencesCommand == null) {//GEN-END:|32-getter|0|32-preInit
            // write pre-init user code here
            preferencesCommand = new Command("Preferences...", Command.SCREEN, 3);//GEN-LINE:|32-getter|1|32-postInit
        // write post-init user code here
        }//GEN-BEGIN:|32-getter|2|
        return preferencesCommand;
    }
    //</editor-fold>//GEN-END:|32-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: okCommand ">//GEN-BEGIN:|35-getter|0|35-preInit
    /**
     * Returns an initiliazed instance of okCommand component.
     * @return the initialized component instance
     */
    public Command getOkCommand() {
        if (okCommand == null) {//GEN-END:|35-getter|0|35-preInit
            // write pre-init user code here
            okCommand = new Command("Ok", Command.OK, 0);//GEN-LINE:|35-getter|1|35-postInit
        // write post-init user code here
        }//GEN-BEGIN:|35-getter|2|
        return okCommand;
    }
    //</editor-fold>//GEN-END:|35-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: cancelCommand ">//GEN-BEGIN:|38-getter|0|38-preInit
    /**
     * Returns an initiliazed instance of cancelCommand component.
     * @return the initialized component instance
     */
    public Command getCancelCommand() {
        if (cancelCommand == null) {//GEN-END:|38-getter|0|38-preInit
            // write pre-init user code here
            cancelCommand = new Command("Cancel", Command.CANCEL, 1);//GEN-LINE:|38-getter|1|38-postInit
        // write post-init user code here
        }//GEN-BEGIN:|38-getter|2|
        return cancelCommand;
    }
    //</editor-fold>//GEN-END:|38-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: preferencesForm ">//GEN-BEGIN:|31-getter|0|31-preInit
    /**
     * Returns an initiliazed instance of preferencesForm component.
     * @return the initialized component instance
     */
    public Form getPreferencesForm() {
        if (preferencesForm == null) {//GEN-END:|31-getter|0|31-preInit
            // write pre-init user code here
            preferencesForm = new Form("Preferences", new Item[] { getChoiceHashFunction(), getChoicePresentation(), getLengthField(), getChoiceStoreDomains() });//GEN-BEGIN:|31-getter|1|31-postInit
            preferencesForm.addCommand(getOkCommand());
            preferencesForm.addCommand(getCancelCommand());
            preferencesForm.setCommandListener(this);//GEN-END:|31-getter|1|31-postInit
            // write post-init user code here
            switch (prefs.getHashFunction()) {
                case HPGenPrefs.MD5:
                    choiceHashFunction.setSelectedIndex(0, true);
                    break;
                case HPGenPrefs.SHA1:
                    choiceHashFunction.setSelectedIndex(1, true);
                    break;
            }
            switch (prefs.getDisplayMode()) {
                case HPGenPrefs.HEX_LOWER:
                    choicePresentation.setSelectedIndex(0, true);
                    break;
                case HPGenPrefs.HEX_UPPER:
                    choicePresentation.setSelectedIndex(1, true);
                    break;
                case HPGenPrefs.BASE64:
                    choicePresentation.setSelectedIndex(2, true);
                    break;
                case HPGenPrefs.BASE64_NO1A:
                    choicePresentation.setSelectedIndex(3, true);
                    break;
            }
            lengthField.setString(new Byte(prefs.getLength()).toString());
            boolean[] storeDomainsSelections = new boolean[choiceStoreDomains.size()];
            if (storeDomainsSelections.length > 0) {
                storeDomainsSelections[0] = prefs.getStoreDomains();
                choiceStoreDomains.setSelectedFlags(storeDomainsSelections);
            }
        }//GEN-BEGIN:|31-getter|2|
        return preferencesForm;
    }
    //</editor-fold>//GEN-END:|31-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: choiceHashFunction ">//GEN-BEGIN:|41-getter|0|41-preInit
    /**
     * Returns an initiliazed instance of choiceHashFunction component.
     * @return the initialized component instance
     */
    public ChoiceGroup getChoiceHashFunction() {
        if (choiceHashFunction == null) {//GEN-END:|41-getter|0|41-preInit
            // write pre-init user code here
            choiceHashFunction = new ChoiceGroup("Hash Function", Choice.EXCLUSIVE);//GEN-BEGIN:|41-getter|1|41-postInit
            choiceHashFunction.append("MD5", null);
            choiceHashFunction.append("SHA1", null);
            choiceHashFunction.setSelectedFlags(new boolean[] { false, true });
//GEN-END:|41-getter|1|41-postInit
        // write post-init user code here
        }//GEN-BEGIN:|41-getter|2|
        return choiceHashFunction;
    }
    //</editor-fold>//GEN-END:|41-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: choicePresentation ">//GEN-BEGIN:|44-getter|0|44-preInit
    /**
     * Returns an initiliazed instance of choicePresentation component.
     * @return the initialized component instance
     */
    public ChoiceGroup getChoicePresentation() {
        if (choicePresentation == null) {//GEN-END:|44-getter|0|44-preInit
            // write pre-init user code here
            choicePresentation = new ChoiceGroup("Presentation", Choice.EXCLUSIVE);//GEN-BEGIN:|44-getter|1|44-postInit
            choicePresentation.append("Lower-case hex", null);
            choicePresentation.append("Upper-case hex", null);
            choicePresentation.append("BASE64", null);
            choicePresentation.append("BASE64 (no suffix)", null);
            choicePresentation.setSelectedFlags(new boolean[] { false, false, true, false });
//GEN-END:|44-getter|1|44-postInit
        // write post-init user code here
        }//GEN-BEGIN:|44-getter|2|
        return choicePresentation;
    }
    //</editor-fold>//GEN-END:|44-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: lengthField ">//GEN-BEGIN:|52-getter|0|52-preInit
    /**
     * Returns an initiliazed instance of lengthField component.
     * @return the initialized component instance
     */
    public TextField getLengthField() {
        if (lengthField == null) {//GEN-END:|52-getter|0|52-preInit
            // write pre-init user code here
            lengthField = new TextField("Length (default 8)", "8", 2, TextField.NUMERIC);//GEN-LINE:|52-getter|1|52-postInit
        // write post-init user code here
        }//GEN-BEGIN:|52-getter|2|
        return lengthField;
    }
    //</editor-fold>//GEN-END:|52-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: chooseDomainCommand ">//GEN-BEGIN:|55-getter|0|55-preInit
    /**
     * Returns an initiliazed instance of chooseDomainCommand component.
     * @return the initialized component instance
     */
    public Command getChooseDomainCommand() {
        if (chooseDomainCommand == null) {//GEN-END:|55-getter|0|55-preInit
            // write pre-init user code here
            chooseDomainCommand = new Command("Choose Domain...", Command.SCREEN, 1);//GEN-LINE:|55-getter|1|55-postInit
        // write post-init user code here
        }//GEN-BEGIN:|55-getter|2|
        return chooseDomainCommand;
    }
    //</editor-fold>//GEN-END:|55-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: domainField ">//GEN-BEGIN:|57-getter|0|57-preInit
    /**
     * Returns an initiliazed instance of domainField component.
     * @return the initialized component instance
     */
    public TextField getDomainField() {
        if (domainField == null) {//GEN-END:|57-getter|0|57-preInit
            // write pre-init user code here
            domainField = new TextField("Enter Domain:", null, 32, TextField.ANY);//GEN-LINE:|57-getter|1|57-postInit
        // write post-init user code here
        }//GEN-BEGIN:|57-getter|2|
        return domainField;
    }
    //</editor-fold>//GEN-END:|57-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: okChooseDomainCommand ">//GEN-BEGIN:|59-getter|0|59-preInit
    /**
     * Returns an initiliazed instance of okChooseDomainCommand component.
     * @return the initialized component instance
     */
    public Command getOkChooseDomainCommand() {
        if (okChooseDomainCommand == null) {//GEN-END:|59-getter|0|59-preInit
            // write pre-init user code here
            okChooseDomainCommand = new Command("Ok", Command.OK, 0);//GEN-LINE:|59-getter|1|59-postInit
        // write post-init user code here
        }//GEN-BEGIN:|59-getter|2|
        return okChooseDomainCommand;
    }
    //</editor-fold>//GEN-END:|59-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: cancelChooseDomainCommand ">//GEN-BEGIN:|61-getter|0|61-preInit
    /**
     * Returns an initiliazed instance of cancelChooseDomainCommand component.
     * @return the initialized component instance
     */
    public Command getCancelChooseDomainCommand() {
        if (cancelChooseDomainCommand == null) {//GEN-END:|61-getter|0|61-preInit
            // write pre-init user code here
            cancelChooseDomainCommand = new Command("Cancel", Command.CANCEL, 1);//GEN-LINE:|61-getter|1|61-postInit
        // write post-init user code here
        }//GEN-BEGIN:|61-getter|2|
        return cancelChooseDomainCommand;
    }
    //</editor-fold>//GEN-END:|61-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: chooseDomainForm ">//GEN-BEGIN:|58-getter|0|58-preInit
    /**
     * Returns an initiliazed instance of chooseDomainForm component.
     * @return the initialized component instance
     */
    public Form getChooseDomainForm() {
        if (chooseDomainForm == null) {//GEN-END:|58-getter|0|58-preInit
            // write pre-init user code here
            chooseDomainForm = new Form("Choose Domain:", new Item[] { getChoiceDomain() });//GEN-BEGIN:|58-getter|1|58-postInit
            chooseDomainForm.addCommand(getOkChooseDomainCommand());
            chooseDomainForm.addCommand(getCancelChooseDomainCommand());
            chooseDomainForm.setCommandListener(this);//GEN-END:|58-getter|1|58-postInit
        // write post-init user code here
        }//GEN-BEGIN:|58-getter|2|
        return chooseDomainForm;
    }
    //</editor-fold>//GEN-END:|58-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: choiceDomain ">//GEN-BEGIN:|64-getter|0|64-preInit
    /**
     * Returns an initiliazed instance of choiceDomain component.
     * @return the initialized component instance
     */
    public ChoiceGroup getChoiceDomain() {
        if (choiceDomain == null) {//GEN-END:|64-getter|0|64-preInit
            // write pre-init user code here
            choiceDomain = new ChoiceGroup("", Choice.EXCLUSIVE);//GEN-LINE:|64-getter|1|64-postInit
        // write post-init user code here
        }//GEN-BEGIN:|64-getter|2|
        return choiceDomain;
    }
    //</editor-fold>//GEN-END:|64-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: aboutCommand ">//GEN-BEGIN:|73-getter|0|73-preInit
    /**
     * Returns an initiliazed instance of aboutCommand component.
     * @return the initialized component instance
     */
    public Command getAboutCommand() {
        if (aboutCommand == null) {//GEN-END:|73-getter|0|73-preInit
            // write pre-init user code here
            aboutCommand = new Command("About...", Command.SCREEN, 4);//GEN-LINE:|73-getter|1|73-postInit
        // write post-init user code here
        }//GEN-BEGIN:|73-getter|2|
        return aboutCommand;
    }
    //</editor-fold>//GEN-END:|73-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: manageDomainsCommand ">//GEN-BEGIN:|77-getter|0|77-preInit
    /**
     * Returns an initiliazed instance of manageDomainsCommand component.
     * @return the initialized component instance
     */
    public Command getManageDomainsCommand() {
        if (manageDomainsCommand == null) {//GEN-END:|77-getter|0|77-preInit
            // write pre-init user code here
            manageDomainsCommand = new Command("Manage Domains...", Command.SCREEN, 2);//GEN-LINE:|77-getter|1|77-postInit
        // write post-init user code here
        }//GEN-BEGIN:|77-getter|2|
        return manageDomainsCommand;
    }
    //</editor-fold>//GEN-END:|77-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: backCommand ">//GEN-BEGIN:|81-getter|0|81-preInit
    /**
     * Returns an initiliazed instance of backCommand component.
     * @return the initialized component instance
     */
    public Command getBackCommand() {
        if (backCommand == null) {//GEN-END:|81-getter|0|81-preInit
            // write pre-init user code here
            backCommand = new Command("Back", Command.BACK, 0);//GEN-LINE:|81-getter|1|81-postInit
        // write post-init user code here
        }//GEN-BEGIN:|81-getter|2|
        return backCommand;
    }
    //</editor-fold>//GEN-END:|81-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: deleteCommand ">//GEN-BEGIN:|84-getter|0|84-preInit
    /**
     * Returns an initiliazed instance of deleteCommand component.
     * @return the initialized component instance
     */
    public Command getDeleteCommand() {
        if (deleteCommand == null) {//GEN-END:|84-getter|0|84-preInit
            // write pre-init user code here
            deleteCommand = new Command("Delete Selected", Command.SCREEN, 0);//GEN-LINE:|84-getter|1|84-postInit
        // write post-init user code here
        }//GEN-BEGIN:|84-getter|2|
        return deleteCommand;
    }
    //</editor-fold>//GEN-END:|84-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: selectAllCommand ">//GEN-BEGIN:|86-getter|0|86-preInit
    /**
     * Returns an initiliazed instance of selectAllCommand component.
     * @return the initialized component instance
     */
    public Command getSelectAllCommand() {
        if (selectAllCommand == null) {//GEN-END:|86-getter|0|86-preInit
            // write pre-init user code here
            selectAllCommand = new Command("Select All", Command.SCREEN, 0);//GEN-LINE:|86-getter|1|86-postInit
        // write post-init user code here
        }//GEN-BEGIN:|86-getter|2|
        return selectAllCommand;
    }
    //</editor-fold>//GEN-END:|86-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: selectNoneCommand ">//GEN-BEGIN:|88-getter|0|88-preInit
    /**
     * Returns an initiliazed instance of selectNoneCommand component.
     * @return the initialized component instance
     */
    public Command getSelectNoneCommand() {
        if (selectNoneCommand == null) {//GEN-END:|88-getter|0|88-preInit
            // write pre-init user code here
            selectNoneCommand = new Command("Select None", Command.SCREEN, 0);//GEN-LINE:|88-getter|1|88-postInit
        // write post-init user code here
        }//GEN-BEGIN:|88-getter|2|
        return selectNoneCommand;
    }
    //</editor-fold>//GEN-END:|88-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: manageDomainsForm ">//GEN-BEGIN:|79-getter|0|79-preInit
    /**
     * Returns an initiliazed instance of manageDomainsForm component.
     * @return the initialized component instance
     */
    public Form getManageDomainsForm() {
        if (manageDomainsForm == null) {//GEN-END:|79-getter|0|79-preInit
            // write pre-init user code here
            manageDomainsForm = new Form("Manage Domains", new Item[] { getManageDomainsChoiceGroup() });//GEN-BEGIN:|79-getter|1|79-postInit
            manageDomainsForm.addCommand(getBackCommand());
            manageDomainsForm.addCommand(getDeleteCommand());
            manageDomainsForm.addCommand(getSelectAllCommand());
            manageDomainsForm.addCommand(getSelectNoneCommand());
            manageDomainsForm.setCommandListener(this);//GEN-END:|79-getter|1|79-postInit
        // write post-init user code here
        }//GEN-BEGIN:|79-getter|2|
        return manageDomainsForm;
    }
    //</editor-fold>//GEN-END:|79-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: manageDomainsChoiceGroup ">//GEN-BEGIN:|83-getter|0|83-preInit
    /**
     * Returns an initiliazed instance of manageDomainsChoiceGroup component.
     * @return the initialized component instance
     */
    public ChoiceGroup getManageDomainsChoiceGroup() {
        if (manageDomainsChoiceGroup == null) {//GEN-END:|83-getter|0|83-preInit
            // write pre-init user code here
            manageDomainsChoiceGroup = new ChoiceGroup("", Choice.MULTIPLE);//GEN-LINE:|83-getter|1|83-postInit
        // write post-init user code here
        }//GEN-BEGIN:|83-getter|2|
        return manageDomainsChoiceGroup;
    }
    //</editor-fold>//GEN-END:|83-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: okCommand1 ">//GEN-BEGIN:|100-getter|0|100-preInit
    /**
     * Returns an initiliazed instance of okCommand1 component.
     * @return the initialized component instance
     */
    public Command getOkCommand1() {
        if (okCommand1 == null) {//GEN-END:|100-getter|0|100-preInit
            // write pre-init user code here
            okCommand1 = new Command("Ok", Command.OK, 0);//GEN-LINE:|100-getter|1|100-postInit
        // write post-init user code here
        }//GEN-BEGIN:|100-getter|2|
        return okCommand1;
    }
    //</editor-fold>//GEN-END:|100-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: aboutForm ">//GEN-BEGIN:|97-getter|0|97-preInit
    /**
     * Returns an initiliazed instance of aboutForm component.
     * @return the initialized component instance
     */
    public Form getAboutForm() {
        if (aboutForm == null) {//GEN-END:|97-getter|0|97-preInit
            // write pre-init user code here
            aboutForm = new Form("About HPGen", new Item[] { getStringItem1() });//GEN-BEGIN:|97-getter|1|97-postInit
            aboutForm.addCommand(getOkCommand1());
            aboutForm.setCommandListener(this);//GEN-END:|97-getter|1|97-postInit
        // write post-init user code here
        }//GEN-BEGIN:|97-getter|2|
        return aboutForm;
    }
    //</editor-fold>//GEN-END:|97-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: stringItem1 ">//GEN-BEGIN:|99-getter|0|99-preInit
    /**
     * Returns an initiliazed instance of stringItem1 component.
     * @return the initialized component instance
     */
    public StringItem getStringItem1() {
        if (stringItem1 == null) {//GEN-END:|99-getter|0|99-preInit
            // write pre-init user code here
            stringItem1 = new StringItem(null, "HPGen password generator, (c) S Jolly 2009. Released under the GPL v2.  Uses Tim Macinta\'s MD5 implementation and Sam Ruby\'s SHA1 implementation.  Hash password concept by Nic Wolff.  See http://elvum.net/hpgen for latest version, help, licensing information and source code.");//GEN-LINE:|99-getter|1|99-postInit
        // write post-init user code here
        }//GEN-BEGIN:|99-getter|2|
        return stringItem1;
    }
    //</editor-fold>//GEN-END:|99-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: choiceStoreDomains ">//GEN-BEGIN:|105-getter|0|105-preInit
    /**
     * Returns an initiliazed instance of choiceStoreDomains component.
     * @return the initialized component instance
     */
    public ChoiceGroup getChoiceStoreDomains() {
        if (choiceStoreDomains == null) {//GEN-END:|105-getter|0|105-preInit
            // write pre-init user code here
            choiceStoreDomains = new ChoiceGroup("", Choice.MULTIPLE);//GEN-BEGIN:|105-getter|1|105-postInit
            choiceStoreDomains.append("Store domain names?", null);
            choiceStoreDomains.setSelectedFlags(new boolean[] { true });
//GEN-END:|105-getter|1|105-postInit
        // write post-init user code here
        }//GEN-BEGIN:|105-getter|2|
        return choiceStoreDomains;
    }
    //</editor-fold>//GEN-END:|105-getter|2|

    /**
     * Returns a display instance.
     * @return the display instance.
     */
    public Display getDisplay() {
        return Display.getDisplay(this);
    }

    /**
     * Exits MIDlet.
     */
    public void exitMIDlet() {
//        switchDisplayable(null, null);
        destroyApp(true);
        notifyDestroyed();
    }

    /**
     * Called when MIDlet is started.
     * Checks whether the MIDlet have been already started and initialize/starts or resumes the MIDlet.
     */
    public void startApp() {
        if (midletPaused) {
            resumeMIDlet();
        } else {
            initialize();
            startMIDlet();
        }
        midletPaused = false;
    }

    /**
     * Called when MIDlet is paused.
     */
    public void pauseApp() {
        midletPaused = true;
    }

    /**
     * Called to signal the MIDlet to terminate.
     * @param unconditional if true, then the MIDlet has to be unconditionally terminated and all resources has to be released.
     */
    public void destroyApp(boolean unconditional) {
    }

    /** Called when the user selects "Generate" on the mainForm
     */
    public void generate() {
        /*        if (domainField.getString().equals("")) {
        return;
        }
        if (passwordField.getString().equals("")) {
        return;
        }
         */
        String concat = passwordField.getString() + ":" + domainField.getString();
        byte[] hash;
        switch (prefs.getHashFunction()) {
            case HPGenPrefs.MD5:
                md5.Init();
                try {
                    md5.Update(concat, "US-ASCII");
                } catch (UnsupportedEncodingException ex) {
                    ex.printStackTrace();
                    generatedPassword.setText("Internal error.");
                }
                hash = md5.Final();
                break;
            case HPGenPrefs.SHA1:
            default:
                hash = SHA1.encode(concat);
                break;
        }
        String generated;
        switch (prefs.getDisplayMode()) {
            case HPGenPrefs.HEX_LOWER:
                generated = MD5.asHex(hash).substring(0, prefs.getLength());
                break;
            case HPGenPrefs.HEX_UPPER:
                generated = MD5.asHex(hash).toUpperCase().substring(0, prefs.getLength());
                break;
            case HPGenPrefs.BASE64_NO1A:
                generated = Conversions.toBase64(hash).substring(0, prefs.getLength());
                break;
            case HPGenPrefs.BASE64:
            default:
                generated = Conversions.toBase64(hash).substring(0, prefs.getLength()) + "1a";
                break;
        }
        generatedPassword.setText(generated);
        if (prefs.getStoreDomains()) {
            try {
                prefs.exclusiveAddDomain(domainField.getString());
            } catch (RecordStoreException ex) {
                ex.printStackTrace();
            //We'll live if the domain can't be added to the list for some reason
            }
        }
    }

    /**
     * Called when the user selects "OK" in the preferencesForm
     */
    public void savePreferences() {
        switch (choiceHashFunction.getSelectedIndex()) {
            case 0:
                prefs.setHashFunction(HPGenPrefs.MD5);
                break;
            case 1:
                prefs.setHashFunction(HPGenPrefs.SHA1);
                break;
        }
        switch (choicePresentation.getSelectedIndex()) {
            case 0:
                prefs.setDisplayMode(HPGenPrefs.HEX_LOWER);
                break;
            case 1:
                prefs.setDisplayMode(HPGenPrefs.HEX_UPPER);
                break;
            case 2:
                prefs.setDisplayMode(HPGenPrefs.BASE64);
                break;
            case 3:
                prefs.setDisplayMode(HPGenPrefs.BASE64_NO1A);
                break;
        }
        byte length = prefs.getLength();
        try {
            length = Byte.parseByte(lengthField.getString());
        } catch (NumberFormatException ex) {
            ex.printStackTrace();
        }
        if (length <= 0) {
            length = 8;
            lengthField.setString("8");
        }
        prefs.setLength(length);

        boolean[] storeDomainsSelections = new boolean[choiceStoreDomains.size()];
        if (storeDomainsSelections.length > 0) {
            choiceStoreDomains.getSelectedFlags(storeDomainsSelections);
            prefs.setStoreDomains(storeDomainsSelections[0]);
        }
    }

    /** Called when the user selects "OK" in the chooseDomainForm
     */
    public void selectDomain() {
        int selectedDomain = choiceDomain.getSelectedIndex();
        if (selectedDomain != -1) {
            String domainString = choiceDomain.getString(selectedDomain);
            domainField.setString(domainString);
            generatedPassword.setText("");
            //Use the side-effect of the exclusive add method to promote
            //this domain to the top of the list
            try {
                prefs.exclusiveAddDomain(domainString);
            } catch (RecordStoreException ex) {
                ex.printStackTrace();
            }
        }
    }
}
